

#include "Incomplete.h"

#include <RobotAPI/components/skills/SkillProviderExample/aron/HelloWorldAcceptedType.aron.generated.h>

#include "HelloWorld.h"

namespace armarx::skills::provider
{

    IncompleteSkill::IncompleteSkill() : SimpleSkill(GetSkillDescription())
    {
    }

    SkillDescription
    IncompleteSkill::GetSkillDescription()
    {
        auto d = HelloWorldSkill::GetSkillDescription();
        return SkillDescription{.skillId = {.skillName = "Incomplete"},
                                .description = d.description,
                                .timeout = d.timeout + armarx::core::time::Duration::Seconds(2),
                                .parametersType = d.parametersType};
    }

    Skill::PrepareResult
    IncompleteSkill::prepare()
    {
        if (!first_prepared)
        {
            first_prepared = true;

            // set parameters after two seconds...
            std::thread foo(
                [&]()
                {
                    auto d = HelloWorldSkill::GetSkillDescription();
                    std::this_thread::sleep_for(std::chrono::milliseconds(2000));
                    this->setParameters(d.rootProfileDefaults);
                });
            foo.detach();
        }

        return {.status = ActiveOrTerminatedSkillStatus::Succeeded};
    }

    Skill::MainResult
    IncompleteSkill::main(const MainInput& in)
    {
        auto s = HelloWorldSkill();
        return s.mainOfSkill();
    }
} // namespace armarx::skills::provider
