
/*
 * This file is part of ArmarX.
 *
 * ArmarX is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 *
 * ArmarX is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 *
 * @author     Andre Meixner ( andre dot meixner at kit dot edu )
 * @date       2024
 * @copyright  http://www.gnu.org/licenses/gpl-2.0.txt
 *             GNU General Public License
 */

#pragma once

// RobotAPI
#include <RobotAPI/libraries/skills/provider/SimpleSpecializedSkill.h>

#include <RobotAPI/components/skills/SkillProviderExample/aron/RecursiveSkillParams.aron.generated.h>

namespace armarx::skills::provider
{
    class RecursiveSkill : public SimpleSpecializedSkill<skills::Example::RecursiveSkillParams>
    {
    public:
        RecursiveSkill();

        static SkillDescription GetSkillDescription();

    private:
        Skill::MainResult main(const SpecializedMainInput&) final;
    };
} // namespace armarx::skills::provider
