#pragma once

#include <fstream>
#include <string>
#include <vector>

#include <SimoxUtility/json.h>

#include "datatypes/Affordance.h"

namespace armarx::priorknowledge::util
{
    class AffordanceLoader
    {
    public:
        static const constexpr auto DEFAULT_FILE_NAME = "affordances.json";
        static const constexpr auto DEFAULT_LOCATION_FILE_NAME = "location_affordances.json";

        AffordanceLoader() = delete;

        static std::vector<StaticAffordance> LoadAffordances(const std::string& sourceId,
                                                             const nlohmann::json&);

        static std::vector<LocationAffordance> LoadLocationAffordances(const std::string& sourceId,
                                                                        const nlohmann::json&);
    };
} // namespace armarx::priorknowledge::util
