#include "CommonPlaceLoader.h"

#include <ArmarXCore/core/eigen/ice_conversions.h>
#include <ArmarXCore/core/logging/Logging.h>

namespace armarx::priorknowledge::util
{

    std::vector<CommonPlace>
    CommonPlaceLoader::LoadCommonPlaces(const std::string& source, const nlohmann::json& js)
    {
        std::vector<CommonPlace> ret;
        if (not js.contains("common_places"))
        {
            ARMARX_WARNING << "The common_places file (" << source << ") has the wrong structure. Missing key 'common_places'.";
            return ret;
        }

        for (const auto& [locationName, priority] :
             js["common_places"].get<std::map<std::string, int>>())
        {
            CommonPlace a{source, locationName, priority};
            ret.push_back(a);
        }
        return ret;
    }
} // namespace armarx::priorknowledge::util
