#pragma once

#include <fstream>
#include <string>
#include <vector>

#include <SimoxUtility/json.h>

#include <RobotAPI/libraries/PriorKnowledge/util/LocationLoader/datatypes/Location.h>

namespace armarx::priorknowledge::util
{
    class LocationLoader
    {
    public:
        static const constexpr auto DEFAULT_FILE_NAME = "locations.json";

        LocationLoader() = delete;

        //        static std::vector<FramedLocation> LoadFramedLocations(const std::string& dataset,
        //                                                               const nlohmann::json&);
        //        static std::vector<FramedBoxedLocation> LoadBoxedLocations(const std::string& dataset,
        //                                                                   const nlohmann::json&);
        static std::vector<LocationPtr> LoadLocations(const std::string& dataset,
                                                      const nlohmann::json&);

    private:
        static FramedLocationPtr LoadFramedLocation(const std::string& source,
                                                    const std::string& locationName,
                                                    const nlohmann::json& j);

        static FramedBoxedLocationPtr LoadBoxedLocation(const std::string& source,
                                                        const std::string& locationName,
                                                        const nlohmann::json& j);
    };
} // namespace armarx::priorknowledge::util
