#pragma once

#include <vector>

#include "memory_definitions.h"
#include "RobotAPI/libraries/armem/server/wm/memory_definitions.h"

namespace armarx::armem::wm
{
    void toMemory(Memory& m, const std::vector<CoreSegment>& e);
    void toMemory(Memory& m, const std::vector<ProviderSegment>& e);
    void toMemory(Memory& m, const std::vector<Entity>& e);
    void toMemory(Memory& m, const std::vector<EntitySnapshot>& e);

    /**
     * @brief toMemory converts a vector of entity snapshots into a working memory and considers
     * the structure of the memory before
     * @param m the (empty) new memory
     * @param structure the server working memory for structure information
     * @param e the vector of entity snapshots
     */
    void toMemory(Memory& m, const armarx::armem::server::wm::Memory& structure, const std::vector<EntitySnapshot>& e);

    void toMemory(Memory& m, const std::vector<EntityInstance>& e);
} // namespace armarx::armem::wm
