#pragma once

// Base Class
#include "../../../../extractor/imageExtractor/ImageExtractor.h"
#include "../Converter.h"

namespace armarx::armem::server::ltm::processor::converter::data::image
{
    class PngConverter : public ImageConverter
    {
    public:
        static const constexpr char* NAME = "PngConverter";

        PngConverter() :
            ImageConverter(ConverterType::Binary,
                           "image",
                           ".png",
                           std::make_unique<extractor::ImageExtractor>())
        {
        }

        void configure(const nlohmann::json& json) override;


    protected:
        ConversionResult _convert(const aron::data::NDArrayPtr& data) final;
        aron::data::NDArrayPtr _convert(const ConversionResult& data,
                                        const armarx::aron::Path& p) final;
    };
} // namespace armarx::armem::server::ltm::processor::converter::data::image
