#include "MaxHistorySize.h"

#include <ArmarXCore/core/logging/Logging.h>


namespace armarx::armem::server::wm::detail
{
    void MaxHistorySize::setMaxHistorySize(long maxSize, const std::string& additionalInfo)
    {
        if (maxSize < 0){
            if(additionalInfo == ""){
                ARMARX_DEBUG << "The maxHistorySize for this memory entity is set to < 0. "
                             << "This means nothing will ever be forgotten in working memory. "
                             << "This may slow down the memory server. \n"
                            << "It is better to set the maxHistorySize per Provider- or CoreSegment";
            } else {
                ARMARX_DEBUG << "The maxHistorySize for this memory entity is set to < 0. "
                             << "This means nothing will ever be forgotten in working memory. "
                             << "This may slow down the memory server."
                             << "The entity name is " << additionalInfo;
            }
        }
        this->_maxHistorySize = maxSize;
    }

    long MaxHistorySize::getMaxHistorySize() const
    {
        return _maxHistorySize;
    }
}
