#include "aron_conversions.h"

#include <RobotAPI/libraries/ArmarXObjects/aron_conversions.h>
#include <RobotAPI/libraries/aron/common/aron_conversions.h>

namespace armarx::armem::robot_state::description
{

    void
    fromAron(const arondto::ObjectClass& dto, RobotDescription& bo)
    {
        bo.name = aron::fromAron<armarx::ObjectID>(dto.id).str();
        fromAron(dto.articulatedSimoxXmlPath, bo.xml);
    }

    void
    toAron(arondto::ObjectClass& dto, const RobotDescription& bo)
    {
        toAron(dto.id, ObjectID(bo.name));
        toAron(dto.articulatedSimoxXmlPath, bo.xml);
    }
} // namespace armarx::armem::robot_state::description

namespace armarx::armem::robot_state
{
    void
    fromAron(const arondto::ObjectInstance& dto, RobotState& bo)
    {
        fromAron(dto.pose, bo);
    }

    void
    toAron(arondto::ObjectInstance& dto, const RobotState& bo)
    {
        toAron(dto.pose, bo);
    }

    void
    fromAron(const objpose::arondto::ObjectPose& dto, RobotState& bo)
    {
        aron::fromAron(dto.timestamp, bo.timestamp);
        aron::fromAron(dto.objectPoseGlobal, bo.globalPose);
        aron::fromAron(dto.objectJointValues, bo.jointMap);
    }

    void
    toAron(objpose::arondto::ObjectPose& dto, const RobotState& bo)
    {
        aron::toAron(dto.timestamp, bo.timestamp);
        aron::toAron(dto.objectPoseGlobal, bo.globalPose.matrix());
        aron::toAron(dto.objectJointValues, bo.jointMap);
    }


} // namespace armarx::armem::robot_state
