#pragma once


#include <ArmarXCore/core/logging/Logging.h>
#include <ArmarXCore/core/services/tasks/TaskUtil.h>

#include <ArmarXGui/libraries/RemoteGui/Client/Widgets.h>

#include <RobotAPI/components/ArViz/Client/Client.h>
#include <RobotAPI/interface/objectpose/ObjectPoseStorageInterface.h>
#include <RobotAPI/libraries/ArmarXObjects/ObjectPose.h>
#include <RobotAPI/libraries/armem_objects/aron/FamiliarObjectInstance.aron.generated.h>
#include <RobotAPI/libraries/armem_objects/server/instance/visu/LinearPredictionsVisu.h>

namespace armarx
{
    class ObjectFinder;
}

namespace armarx::armem::server::obj::familiar_object_instance
{

    /**
     * @brief Models decay of object localizations by decreasing the confidence
     * the longer the object was not localized.
     */
    class Visu : public armarx::Logging
    {
    public:
        void defineProperties(armarx::PropertyDefinitionsPtr defs,
                              const std::string& prefix = "visu.");


        void visualizeFamiliarObjectsByProvider(
            const std::map<std::string,
                           std::vector<armarx::armem::arondto::FamiliarObjectInstance>>&
                familiarObjectsByProvider);


        viz::Client arviz;

        bool enabled = true;
        float frequencyHz = 25;

        bool inGlobalFrame = true;
        float minConfidence = -1;
        float alpha = 1.0;
        bool alphaByConfidence = false;
        bool oobbs = false;

        std::uint8_t sizePixel = 5;

        bool visualizePointCloud = true;
        bool visualizeBoundingBox = true;
        bool visualizePose = true;

        bool objectFrames = false;
        float objectFramesScale = 1.0;

        float visualizationDuration = 20; //[s]


        SimpleRunningTask<>::pointer_type updateTask;

    };

} // namespace armarx::armem::server::obj::familiar_object_instance
