#pragma once


#include <RobotAPI/libraries/armem/core/Time.h>
#include <RobotAPI/libraries/armem/core/forward_declarations.h>
#include <RobotAPI/libraries/armem_robot_state/types.h>

namespace armarx::armem::robot_state
{
    class ReaderInterface
    {
    public:
        virtual ~ReaderInterface() = default;

        virtual bool synchronize(Robot& obj, const armem::Time& timestamp) const = 0;

        virtual Robot get(const description::RobotDescription& description,
                          const armem::Time& timestamp) const = 0;
        virtual std::optional<Robot> get(const std::string& name,
                                         const armem::Time& timestamp) const = 0;
    };


} // namespace armarx::armem::robot_state
