#include "ConverterRegistry.h"

#include "ArmarDEConverter.h"

#include <SimoxUtility/algorithm/get_map_keys_values.h>


namespace armarx::armem::server::robot_state::exteroception
{

    ConverterRegistry::ConverterRegistry()
    {
        add<ArmarDEConverter>("ArmarDE");
        add<ArmarDEConverter>("Armar7");
    }


    ConverterInterface*
    ConverterRegistry::get(const std::string& key) const
    {
        auto it = converters.find(key);
        return it != converters.end() ? it->second.get() : nullptr;
    }


    std::vector<std::string> ConverterRegistry::getKeys() const
    {
        return simox::alg::get_keys(converters);
    }

}
