#pragma once

#include <vector>
#include "RobotAPI/libraries/aron/core/data/variant/complex/NDArray.h"

namespace armarx::aron::similarity::NDArraySimilarity{

    enum Type {
        MSE,
        MAE,
        CHERNOFF,
        COSINE,
        NONE
    };

    std::string to_string(Type t);

    double calculate_similarity(armarx::aron::data::NDArrayPtr p1, armarx::aron::data::NDArrayPtr p2, Type type);

    /**
     * @brief calculate_similarity_multi compares the image p with all images from the images vector, the dissimilarity values are simply summed up
     * @param images vector of images that are compared to p
     * @param p main image that you want to know the dissimilarity from
     * @param type Type of dissimilarity measure used
     * @return dissimilarity
     */
    double calculate_similarity_multi(std::vector<armarx::aron::data::NDArrayPtr> images, armarx::aron::data::NDArrayPtr p, Type type);

}
