#include "mae.h"

namespace armarx::aron::similarity::mae
{

    double compute_similarity(const data::NDArrayPtr p1, const data::NDArrayPtr p2)
    {
        double sum = 0;
        int width = p1->getShape().at(0);
        int height = p1->getShape().at(1);
        int colors = p1->getShape().at(2);

        auto first_image = p1->getDataAsVector();
        auto second_image = p2->getDataAsVector();

        ARMARX_CHECK(first_image.size() == second_image.size());

        for (int w = 0; w < width; w++){
            for (int h = 0; h < height; h++){
                for (int c = 0; c < colors; c++){
                    int k = h * width * colors + w * colors + c;
                    sum += std::abs(first_image.at(k) - second_image.at(k));
                }
            }
        }
        return sum / (width * height * colors);
    }


}

