#include "json_conversions.h"

#include <RobotAPI/libraries/core/FramedPose.h>
#include <RobotAPI/libraries/core/Names.h>

void
armarx::to_json(nlohmann::json& j, const FramedPose& fp)
{
    j = nlohmann::json{{"agent", fp.agent},
                       {"frame", fp.frame},
                       {"qw", fp.orientation->qw},
                       {"qx", fp.orientation->qx},
                       {"qy", fp.orientation->qy},
                       {"qz", fp.orientation->qz},
                       {"x", fp.position->x},
                       {"y", fp.position->y},
                       {"z", fp.position->z}};
}

void
armarx::from_json(const nlohmann::json& j, FramedPose& fp)
{
    j.at("agent").get_to(fp.agent);
    j.at("frame").get_to(fp.frame);
    j.at("qw").get_to(fp.orientation->qw);
    j.at("qx").get_to(fp.orientation->qx);
    j.at("qy").get_to(fp.orientation->qy);
    j.at("qz").get_to(fp.orientation->qz);
    j.at("x").get_to(fp.position->x);
    j.at("y").get_to(fp.position->y);
    j.at("z").get_to(fp.position->z);
}

void
armarx::to_json(simox::json::json& j, const Names& value)
{
    j["recognized"] = value.recognized;
    j["spoken"] = value.spoken;
}

void
armarx::from_json(const simox::json::json& j, Names& value)
{
    j.at("recognized").get_to(value.recognized);
    j.at("spoken").get_to(value.spoken);
}
