#pragma once

#include <RobotAPI/libraries/skills/core/Skill.h>

namespace armarx
{
    namespace skills
    {
        class LambdaSkill : public Skill
        {
        public:
            using FunctionType = std::function<TerminatedSkillStatus()>;

            LambdaSkill() = delete;
            LambdaSkill(const SkillDescription& desc, const FunctionType& f) : Skill(desc), fun(f){};

        private:
            MainResult main() override;

        private:
            FunctionType fun;
        };
    } // namespace skills
} // namespace armarx
