#pragma once

#include <RobotAPI/libraries/aron/core/type/variant/container/Object.h>
#include <RobotAPI/libraries/skills/core/Skill.h>

namespace armarx::skills
{
    template <class AronT>
    class SpecializedSkill : public Skill
    {
    public:
        using Base = Skill;
        using ParamType = AronT;

        using Skill::Skill;
        virtual ~SpecializedSkill() = default;

        void
        setParameters(const AronT& d)
        {
            Base::setParameters(d.toAron());
        }

        /// Overwrite getter for parameters. Shadow Skill::getParameters()
        AronT
        getParameters() const
        {
            AronT d;
            d.fromAron(this->parameters);
            return d;
        }

        /// returns the accepted type of the skill
        static armarx::aron::type::ObjectPtr
        GetAcceptedType()
        {
            return AronT::ToAronType();
        }


    protected:
    };
} // namespace armarx::skills
